from collections import namedtuple
from dataclasses import dataclass

@dataclass
class QueryRow:
    start_node: str
    target_node: str
    query_time: float
    trip_time: float
    nodes: int
    edges: int
    charging_stations: int


@dataclass
class GasstationQueryRow(QueryRow):
    time_contracted_graph: float
    time_state_graph: float


@dataclass
class ChargeQueryRow(QueryRow):
    time_contracted_graph: float
    time_state_graph: float


@dataclass
class ClassicQueryRow(QueryRow):
    dijkstra_rank: int


@dataclass
class AStarQueryRow(QueryRow):
    pass


Query = namedtuple('Query',
                   field_names=['query_function', 'filename', 'row_dataclass'])
